Attribute VB_Name = "MTestWindow"
Private Const GW_HWNDNEXT = 2

Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal HWnd As Long, lpdwProcessId As Long) As Long
Private Declare Function GetParent Lib "user32" (ByVal HWnd As Long) As Long
Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As Long, ByVal lpWindowName As Long) As Long
Private Declare Function GetWindow Lib "user32" (ByVal HWnd As Long, ByVal wCmd As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal HWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Public Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long

Public old_parent As Long
Public child_hwnd As Long

'Show Window
'Brings back inside MDI but minimized if notepad was minimized
Private Declare Function SetForegroundWindow Lib "user32" (ByVal HWnd As Long) As Long

'Minimize Window
Private Declare Function CloseWindow Lib "user32" (ByVal HWnd As Long) As Long

'Maximize Window
Private Const SW_MAXIMIZE = 3
'Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function ShowWindow Lib "user32" (ByVal HWnd As Long, ByVal nCmdShow As Long) As Long

'Close (Terminate) Window
Const WM_CLOSE = &H10
Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal HWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Private Function InstanceToWnd(ByVal target_pid As Long) As Long
'Return the window handle for an instance handle.
'This came from VB-Helper, but See Q242308 appears to be original

Dim test_hwnd As Long
Dim test_pid As Long
Dim test_thread_id As Long

    ' Get the first window handle.
    test_hwnd = FindWindow(ByVal 0&, ByVal 0&)

    ' Loop until we find the target or we run out
    ' of windows.
    Do While test_hwnd <> 0
        ' See if this window has a parent. If not,
        ' it is a top-level window.
        If GetParent(test_hwnd) = 0 Then
            ' This is a top-level window. See if
            ' it has the target instance handle.
            test_thread_id = GetWindowThreadProcessId(test_hwnd, test_pid)

            If test_pid = target_pid Then
                ' This is the target.
                InstanceToWnd = test_hwnd
                Exit Do
            End If
        End If

        ' Examine the next window.
        test_hwnd = GetWindow(test_hwnd, GW_HWNDNEXT)
    Loop
End Function

Public Function ShowMDIMinimized(lngHWnd As Long)
'This brings the Window as minimized within the MDI Form
'if it was originally hidden

   Dim dl As Long
   dl = SetForegroundWindow(lngHWnd)
   
End Function

Public Function MinimizeWindow(lngHWnd As Long)
'Hide the Window
   Dim dl As Long
   dl = CloseWindow(lngHWnd)   '<<Minimize
   
End Function

Public Function MaximizeWindow(lngHWnd As Long)
'Maximize the window

   If lngHWnd <> 0 Then
      ShowWindow lngHWnd, SW_MAXIMIZE
   End If
   
End Function

Public Function FreeWindowFromMDI(hChild As Long, hOldParent As Long)

    SetParent hChild, hOldParent

End Function

Public Function TerminateWindow(lngHWnd)

   'Post a message to the window to close itself
    PostMessage lngHWnd, WM_CLOSE, 0&, 0&
    
End Function

Public Function RunWindow(strApp As String)

   Dim pid As Long
'   Dim buf As String
'   Dim buf_len As Long
'   Dim styles As Long

    ' Start the program.
    pid = Shell(strApp, vbNormalFocus)
    If pid = 0 Then
        MsgBox "Error starting program"
        Exit Function
    End If

    ' Get the window handle.
    child_hwnd = InstanceToWnd(pid)
    
MDIForm1.Caption = Str$(child_hwnd)

    ' Reparent the program so it lies inside
    ' the MDI form.
    old_parent = SetParent(child_hwnd, MDIForm1.HWnd)

 
End Function



